// MilkShape 3D mesh exporter
// Just exports the meshes as a chunky list of triangles.
// AKA: I couldn't be arsed to write a full-blown MS3D plugin.
// Just use that JavaScript plugin under "tools" to run this.

fileName = showSaveDlg("Select output file", "*.msh|*.msh|*.*|*.*||")

if (fileName!=null) {

	f = new File(fileName, File.OUT | File.TRUNC);

	num_triangles = 0;
	for (m=0; m<model.meshes.length; ++m) {
		num_triangles += model.meshes[m].triangles.length;
	}
	f.write("["+num_triangles+"]");
	for (m=0; m<model.meshes.length; ++m) {
		for (t=0; t<model.meshes[m].triangles.length; ++t) {
			for (v=0; v<3; ++v) {
				f.write(""+model.meshes[m].vertices[model.meshes[m].triangles[t].vertexIndices[v]].vertex+"");
				f.write("{"+model.meshes[m].vertices[model.meshes[m].triangles[t].vertexIndices[v]].u);
				f.write(","+model.meshes[m].vertices[model.meshes[m].triangles[t].vertexIndices[v]].v+"}");
				f.write(""+model.meshes[m].normals[model.meshes[m].triangles[t].normalIndices[v]]+"");
			}
		}
	}

	f.close();
	n = "Saved " + num_triangles + " triangles to '" + fileName + "'.";
}