#include "stdafx.h"

FSOUND_SAMPLE *background_music;

bool init_music() {
	printf("Starting up FMOD... ");

	if (!FSOUND_Init(22050, 16, FSOUND_INIT_ACCURATEVULEVELS)) {
		console_response(false);
		return false;
	} else {
		console_response(true);
	}

	printf("Loading music... ");
	if (!(background_music=FSOUND_Sample_Load(FSOUND_FREE, "data/Devon Zachary - Undervolting.mp3", FSOUND_NORMAL,0,0))) {
		console_response(false);
		return false;
	} else {
		console_response(true);        
	}

    return true;
}

void shut_down_music() {
	printf("Shutting down FMOD... ");
	FSOUND_Close();
	console_response(true);
}