extern HANDLE wHnd;
extern HANDLE rHnd;
extern CHAR_INFO *console_buffer;
extern BOOL key_pressed[256];
extern CHAR_INFO block_palette[8*8];
extern CHAR_INFO *palette;

extern short *colour_map;

extern int *rgb_map;

extern short quick_rgb_map[0xFFF];

bool set_up_console();
void read_key_presses();

void disp_current_buffer();
void flip_buffers();
void clear_current_buffer();

void shut_down_console();

void disp_blended_buffers(int mode, int amount_from_current);

short get_palette_from_char_info(CHAR_INFO c);

bool save_screenshot(char *filename);

short find_closest_colour(int r, int g, int b);
short quick_find_closest_colour(int r, int g, int b);

void hide_cursor(); 

void send_to_corner(int corner);

void set_console_colour(int foreground, int background);
void reset_console_colour();
void console_response(bool OK);
void console_warning();
